;@xkas
;Sonic-Styled Powerdown Patch by RPG Hacker

header
lorom


!freespace = $148000   ; < POINT TO FREE SPACE



org $00F5F8       ;\ Disable Item Box getting used when hurt
	nop #$4   ;/ 

org $00F600      ;\ Disable Powerup Losing when hurt
        nop #2   ;/

org $00D129	             ;\ Eliminate Powerdown Animation and jump to Flash Routine
	db $EA,$EA,$EA,$80   ;/ was $EA,$EA,$EA,$80

org $009E2C           ;\
        jml newgame   ; | Loading/starting a game from title screen
        nop #2        ;/

org $00F5D5       ;\ Custom Damage Routine
        jml hit   ;/

org $00F5B2               ;\ When falling into a hole or lava
	jsl customdeath   ;/

org $00F606               ;\ Jump to Custom Death Routine
        jml customdeath   ;/

org $00A0E6                ;\ Reset Powerup when you die
       jsl Resetpowerup   ;/

org $009D24            ;\ Jump to 2-Player-Disable Code
	jsl oneplayer  ;/


;;;;;;;;;;;;;;;;;
;MAIN CODE START;
;;;;;;;;;;;;;;;;;

                                    
org !freespace                       ;\
                                     ; |
	db "STAR"                    ; | RATS-Tag
	dw codeend-newgame           ; |
	dw codeend-newgame^#$FFFF    ;/



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Starting a new game/Loading a Game;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        newgame:
        lda #$04
        sta $0DBE
        lda #$02
        sta $19
	stz $0DBF
	ldx $0DB2
	stz $0DC1
  	jml $009E3A



;;;;;;;;;;;;;;;;;
;One Player Only;
;;;;;;;;;;;;;;;;;


        oneplayer:

	inc $0100                   ;\
	lda $0100                   ; |
	cmp #$0A                    ; |
	bne return                  ; |
	inc $0100                   ; |
	pea $8074                   ; | Disable second Player
	pea $9E64                   ; |
	pea $9E12                   ; |
	jmp $00A195                 ; |
                                    ; |
        return:                     ; |
        rtl                         ;/



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Custom Damage Handling and HP Setting;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        hit:              ;\
        lda $7E0DBF       ; | Jump to Death Routine if Coins equal Zero
        cmp #$00          ; |
        beq customdeath   ;/

	stz $0DBF   ; Set Coins to Zero
	
	LDA $186C,x 			;Added for Coin Generation
	BNE EndSpawn
	JSL $02A9DE
	BMI EndSpawn
	LDA #$01
	STA $14C8,y
	LDA #$21  				;Sprite number
	STA $009E,y
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	SEC						;Where to spawn the coin
	SBC #$1B				;
	STA $00D8,y
	LDA $14D4,x
	SBC #$00				
	STA $14D4,y
	LDA #$E0					; Added for Coin speed?
	STA	$00AA,y					;
	PHX
	TYX
	JSL $07F7D2
	PLX
EndSpawn:					;End of Coin Generation
;	RTS

        lda #$38    ;\ Play Hurt Sound
        sta $1DFC   ;/

        lda #$02    ;\ Set Powerup to Super Mario
        sta $19     ;/

        lda $0D9B        ;\
        cmp #$80         ; | Disable Knockback in Iggy/Larry Battles
        beq NoKnockback  ;/

        lda #$D7     ;\
        sta $7D 
                     ; |
        lda $76      ; |
        bne other    ; |
                     ; |
        lda #$29     ; |
        sta $7B      ; |
        bra next     ; | Knockback Code
                     ; |
        other:       ; |
        lda #$D7     ; |
        sta $7B      ; |
					 ; |
        next:        ; |
                     ; |
        NoKnockback: ; |
        jml $00F5DD  ;/

        customdeath:    ;\
	stz $0DBF       ; |
        lda #$90        ; |
        sta $7D         ; |
        lda #$09        ; |
        sta $1DFB       ; |
        lda #$FF        ; | Death Routine Disassembly
        sta $0DDA       ; |
        lda #$09        ; | 
        sta $71         ; |
        stz $140D       ; |
        lda #$30        ; |
        sta $1496       ; |
        sta $9D         ; |
        stz $1407       ; |
        stz $188A       ; |
        rtl             ;/

        Resetpowerup:   ;\
        lda #$02        ; |
        sta $19         ; |
        sta $0DB8       ; | Reset Powerup after Death
        lda #$03        ; |
        sta $44         ; |
        rtl             ;/


codeend:    ; RATS-Tag End
