header
lorom

org $00E385
autoclean JML hijacktilemapper
freecode

hijacktilemapper:
PHB
PHK
PLB

;;;;;;;;;;;;;;;;;;;;;
;Below data deals with X and Y
;positioning of Mario's tiles
;;;;;;;;;;;;;;;;;;;;;

LDX $13E0
CPX #$29
BNE +
LDA $19
BNE +
LDX #$20
+
LDA PosPointPointer,x
ORA $76
TAY
LDA PosPoint,y
STA $05

;;;;;;;;;;;;;;;;;;;;;;;;
;Below deals with Mario's tilemapping
;;;;;;;;;;;;;;;;;;;;;;;;

LDA #$00
STA $06

LDA $64
LDX $13F9		;if Mario is not behind stuff
BEQ ++			;branch away
LDA MarioYXPPCCCT,x

++
LDY.w MarioOAMIndex,x
LDX $76
ORA MarioPalIndex,x
STA $0303,y		;Mario's top tile YXPPCCCT OAM
STA $0307,y		;Mario's bottom tile YXPPCCCT OAM
STA $030B,y		;Extended tile 1 YXPPCCCT OAM
STA $030F,y		;Extended tile 2 YXPPCCCT OAM

STA $0313,y		;Mario's cape YXPPCCCT OAM
STA $02FB,y		;Mario's cape YXPPCCCT OAM (Used when the character is climbing)
STA $02FF,y		;Mario's cape YXPPCCCT OAM (probably for gliding or something)


LDA #$E8
STA $04
JSR TileCheck		;\ JSR four times
LDA #$E8
STA $04
JSR TileCheck		;| to TileCheck
LDA #$E8
STA $04
JSR TileCheck		;| because there are 4 tiles
LDA #$E8
STA $04
JSR TileCheck		;/ that need to be made (top tile, bottom tile, extnd tile 1, extnd tile 2)

LDA $19
CMP #$02		;if not cape
BNE CODE_00E458		;branch away~

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Code handling cape graphics, positioning, and (possibly) interaction.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PHY			;Push Y
LDA #$2C		;load the cape tile from Mario8x8Tiles
STA $06			;into $06
LDX $13E0		;load pose
LDA DATA_00E18E,x	;and load some table?
CMP #$FF
BNE +++
PLY
BRA CODE_00E458

+++
TAX
LDA DATA_00E1D7,x
STA $0D
LDA MisCapeTile,x
STA $0E
LDA DATA_00E1D5,x
STA $0C
CMP #$04		;if 4 or greater
BCS CODE_00E432		;branch away~
LDA $13DF		;load cape image
ASL #2			;multiply by 4
ORA $0C			;OR it by whatever got loaded from DATA_00E1D5
TAY
LDA CapeTilemap,y	;Load cape tilemap
STA $0C
LDA CapePositions,y	;Load "cape position pointers" pointers
BRA CODE_00E435

CODE_00E432:
LDA DATA_00E1D6,x

CODE_00E435:
ORA $76			;OR by Mario's direction
TAY
LDA CapePosPoint,y	;Load cape position pointers
STA $05
PLY			;Pull back Y
LDA DATA_00E1D4,x
TSB $78
BMI CODE_00E448
JSR TileCheck		;Draw another tile

CODE_00E448:
LDX $13F9		;load "Mario goes behind stuff" flag
LDY.w CapeOAMIndex,x
JSR TileCheck		;Draw yet another tile
LDA $0E			;load whatever you got from MisCapeTile
STA $06
JSR TileCheck		;and again

;;;;;;;;;;;;;;;;;;;;;;;;
;END OF LOLCAPE CODE
;;;;;;;;;;;;;;;;;;;;;;;;

CODE_00E458:
PLB
JML $00E458


;;;;;;;;;;;;;;;;;;;;;;;;;;
;Below deals with Mario's tiles
;;;;;;;;;;;;;;;;;;;;;;;;;;

TileCheck:
LSR $78
BCS Skip8x8

LDX $06
LDA Mario8x8Tiles,x
BMI Skip8x8
STA $0302,Y

LDX $05
REP #$20
LDA $80			;Mario Y position
CLC
ADC YPOSITIONNES,x
PHA
CLC
ADC #$0010
CMP #$0100
PLA
SEP #$20
BCS Skip8x8
STA $0301,y

REP #$20
LDA $7E			;Mario X position
CLC
ADC XPOSITIONNES,x
PHA
CLC
ADC #$0080
CMP #$0200
PLA
SEP #$20
BCS Skip8x8
STA $0300,y
XBA
LSR

Skip8x8:
PHP
TYA
LSR #2
TAX
ASL $04
ROL
PLP
ROL
AND #$03
STA $0460,x
INY #4
INC $05
INC $05
INC $06
RTS



TilesetIndex: 
	db $00,$46,$83,$46 

MarioPalIndex:
	db $00,$40

MarioOAMIndex:
	db $10,$D4,$10,$E8

MarioYXPPCCCT:
	db $E0,$10,$10,$30

;;;;;;;;;;;;;;;;
;Format:
;(Note = These tiles all use GFX 00)
;1st byte = Head (16x16)
;2nd byte = Body (16x16)
;3rd byte = Other tile (usually 8x8)
;4th byte = another tile (usually 8x8)
;
;$67 denotes a blank tile
;;;;;;;;;;;;;;;;

Mario8x8Tiles:
db $00,$02,$20,$22	;[00]
db $00,$02,$80,$80	;[04]
db $00,$02,$80,$80	;[08]
db $00,$02,$80,$80	;[0C]
db $00,$02,$80,$80	;[10]
db $00,$02,$80,$80	;[14]
db $00,$02,$80,$80	;[18]
db $00,$02,$80,$80	;[1C]
db $00,$02,$80,$80	;[20]
db $00,$02,$80,$80	;[24]
db $00,$02,$80,$80	;[28]
db $04			;[2C]
db $7F			;[2D]
db $4A,$5B,$4B,$5A	;[2E]




YPOSITIONNES:
dw $0001,$0011,$0001,$0011	;[00]	Normal
dw $0001,$0011,$0001,$0011	;[08]	Normal (facing right)
dw $000F,$000F,$001F,$001F	;[10]	Wall running offsets (^ <-)
dw $000F,$000F,$001F,$001F	;[18]	Wall running offsets (-> ^)
dw $0003,$0013,$0003,$0013	;[20]	Powerdown offsets
dw $0003,$0013,$0003,$0013	;[28]	Powerdown offsets (facing right)

;below are free to use

dw $0001,$0011,$0001,$0011	;[30]
dw $0001,$0011,$0001,$0011	;[38]
dw $0001,$0011,$0001,$0011	;[40]
dw $0001,$0011,$0001,$0011	;[48]
dw $0001,$0011,$0001,$0011	;[50]
dw $0001,$0011,$0001,$0011	;[58]
dw $0001,$0011,$0001,$0011	;[60]
dw $0001,$0011,$0001,$0011	;[68]
dw $0001,$0011,$0001,$0011	;[70]
dw $0001,$0011,$0001,$0011	;[78]
dw $0000,$0000			;[80]

;;;Cape Y positions;;;

dw $000B,$000B			;[84]
dw $000A,$000A,$FFFF,$FFFF
dw $0010,$0010,$0010,$0010
dw $0010,$0010,$0010,$0015
dw $0015,$0025,$0025,$0004
dw $0004,$0004,$0014,$0014
dw $0004,$0014,$0014,$0004
dw $0004,$0014,$0004,$0004
dw $0014,$0000,$0008,$0000
dw $0000,$0008,$0000,$0000
dw $0010,$0018,$0000,$0010
dw $0018,$0000,$0010,$0000
dw $0010,$FFF8



XPOSITIONNES:
dw $FFF8,$FFF8,$0008,$0008	;[00]	Normal
dw $0008,$0008,$FFF8,$FFF8	;[08]	Normal (facing right)
dw $0014,$0004,$0014,$0004	;[10]	Wall running offsets (^ <-)
dw $FFEC,$FFFC,$FFEC,$FFFC	;[18]	Wall running offsets (-> ^)
dw $FFF8,$FFF8,$0008,$0008	;[20]	Powerdown offsets
dw $0008,$0008,$FFF8,$FFF8	;[28]	Powerdown offsets (facing right)

;below are free to use

dw $FFF8,$FFF8,$0008,$0008	;[30]
dw $0008,$0008,$FFF8,$FFF8	;[38]
dw $FFF8,$FFF8,$0008,$0008	;[40]
dw $0008,$0008,$FFF8,$FFF8	;[48]
dw $FFF8,$FFF8,$0008,$0008	;[50]
dw $0008,$0008,$FFF8,$FFF8	;[58]
dw $FFF8,$FFF8,$0008,$0008	;[60]
dw $0008,$0008,$FFF8,$FFF8	;[68]
dw $FFF8,$FFF8,$0008,$0008	;[70]
dw $0008,$0008,$FFF8,$FFF8	;[78]
dw $0000,$0000			;[80]

;;;Cape X positions;;;

dw $000A,$FFF6			;[84]
dw $0008,$FFF8,$0008,$FFF8
dw $0000,$0004,$FFFC,$FFFE
dw $0002,$000B,$FFF5,$0014
dw $FFEC,$000E,$FFF3,$0008
dw $FFF8,$000C,$0014,$FFFD
dw $FFF4,$FFF4,$000B,$000B
dw $0003,$0013,$FFF5,$0005
dw $FFF5,$0009,$0001,$0001
dw $FFF7,$0007,$0007,$0005
dw $000D,$000D,$FFFB,$FFFB
dw $FFFB,$FFFF,$000F,$0001
dw $FFF9,$0000


PosPointPointer:

db $00,$00,$00,$00,$00,$00,$00,$00	;00-07	\
db $00,$00,$00,$00,$00,$00,$00,$00	;08-0F	|
db $00,$02,$02,$02,$00,$00,$00,$00	;10-17	|
db $00,$00,$00,$00,$00,$00,$00,$00	;18-1F	|
db $00,$00,$00,$00,$00,$00,$00,$00	;20-27	|Mario's pose number
db $00,$00,$00,$00,$00,$00,$00,$00	;28-2F	|
db $00,$00,$00,$00,$00,$00,$00,$00	;30-37	|
db $00,$00,$00,$00,$00,$04,$00,$00	;38-3F	|
db $00,$00,$00,$00,$00,$00		;40-45	/

PosPoint:

db $00,$08,$10,$18,$20,$28,$00,$00	;00-07
db $00,$00,$00,$00,$00,$00,$00,$00	;08-0F
db $00,$00,$00,$00,$00,$00,$00,$00	;10-17
db $00,$00,$00,$00			;18-1B


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;CAPE TABLES AHOY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CapeOAMIndex:
	db $08,$CC,$08

DATA_00E18E:

db $00,$00,$00,$00,$00,$00,$00,$00	;[00-07]
db $00,$00,$00,$00,$00,$0D,$00,$10	;[08-0F]
db $13,$22,$25,$28,$00,$16,$00,$00	;[10-17] 
db $00,$00,$00,$00,$00,$08,$19,$1C	;[18-1F]
db $04,$1F,$10,$10,$00,$16,$10,$06	;[20-27] 
db $04,$08,$FF,$FF,$FF,$FF,$FF,$43	;[28-2F]
db $00,$00,$00,$00,$00,$00,$00,$00	;[30-37]
db $16,$16,$00,$00,$08			;[38-3C]
db $00,$00,$00,$00,$00,$00,$10,$04	;[3D-44]
db $00					;[45]

DATA_00E1D4:
	db $06

DATA_00E1D5:
	db $00

DATA_00E1D6:
	db $06

DATA_00E1D7:
	db $00

MisCapeTile:

db $86,$02,$06,$03,$06,$01,$06,$CE
db $06,$06,$40,$00,$06,$2C,$06,$06
db $44,$0E,$86,$2C,$06,$86,$2C,$0A
db $86,$84,$08,$06,$0A,$02,$06,$AC
db $10,$06,$CC,$10,$06,$AE,$10,$00
db $8C,$14,$80,$2E,$00,$CA,$16,$91
db $2F,$00,$8E,$18,$81,$30,$00,$EB
db $1A,$90,$31,$04,$ED,$1C,$82,$06
db $92,$1E

;;
;Cape tilemap
;;

;org $00E23A	;tilemap
CapeTilemap:

db $0A,$0A,$84,$0A	;Standing still, ducking, ?, ?
db $88,$88,$88,$88	;collapsing 2
db $8A,$8A,$8A,$8A	;collapsing 1
db $44,$44,$44,$44	;walking 4
db $42,$42,$42,$42	;walking 3
db $40,$40,$40,$40	;walking 2
db $22,$22,$22,$22	;walking 1
db $A4,$A4,$A4,$A4	;falling 4
db $A6,$A6,$A6,$A6	;falling 3
db $86,$86,$86,$86	;falling 2
db $6E,$6E,$6E,$6E	;falling 1

;;
;For below data:
;
;04 - height at Mario's head
;02 - height at Mario's body
;00 - in between
;other values - I dunno
;;

;org $00E266	;offset
CapePositions:

db $02,$02,$02,$0C	;Standing still, ducking, ?, ?
db $00,$00,$00,$00	;collapsing 2
db $00,$00,$00,$00	;collapsing 1
db $00,$00,$00,$00	;walking 4
db $00,$00,$00,$00	;walking 3
db $00,$00,$00,$00	;walking 2
db $00,$00,$00,$00	;walking 1
db $04,$12,$04,$04	;falling 4
db $04,$12,$04,$04	;falling 3
db $04,$12,$04,$04	;falling 2
db $04,$12,$04,$04	;falling 1

CapePosPoint:

db $84,$86,$88,$8A,$8C,$8E,$90,$90	;[00-07]
db $92,$94,$96,$98,$9A,$9C,$9E,$A0	;[08-0F]
db $A2,$A4,$A6,$A8,$AA,$B0,$B6,$BC	;[10-17]
db $C2,$C8,$CE,$D4,$DA,$DE,$E2,$E2	;[18-1F]


Endingololo2: